;(function(namespace) {
    'use strict';



})(window.pm || (window.pm = {}));


// Super shorthand
// ------------------------------------------------------------------------

Object.defineProperty(window, 'a', {
    get: function(){
        return pm.app;
    }
});

Object.defineProperty(window, 'p', {
    get: function(){
        return pm.State.page;
    }
});

Object.defineProperty(window, 's', {
    get: function(){
        return pm.State;
    }
});

Object.defineProperty(window, 'u', {
    get: function(){
        return pm.State.currentUser();
    }
});


// Extend Backbone
// ------------------------------------------------------------------------

Backbone.View.prototype.log = function() {
    var args = Array.prototype.slice.call(arguments, 0, arguments.length);

    args.unshift("[" + this.name + "]");

    console.log.apply(console, args);
};

Backbone.View.prototype.warn = function() {
    var args = Array.prototype.slice.call(arguments, 0, arguments.length);

    args.unshift("[" + this.name + "]");

    console.warn.apply(console, args);
};

Backbone.View.prototype.color = function() {
    var args = Array.prototype.slice.call(arguments, 0, arguments.length);

    args.push(pm.Colors.VIEW);
    args.unshift("[" + this.name + "] ");

    console.color.apply(console, args);
};


// jQuery Plugins
// ----------------------------------------------------------

$.fn.scrollTo = function(target, options, callback) {
    if (typeof options == 'function' && arguments.length == 2) {
        callback = options;
        options = target;
    }
    var settings = $.extend({
        scrollTarget: target,
        offsetTop: 50,
        duration: 500,
        easing: 'swing'
    }, options);
    return this.each(function() {
        var scrollPane = $(this);
        var scrollTarget = (typeof settings.scrollTarget == "number") ? settings.scrollTarget : $(settings.scrollTarget);
        var scrollY = (typeof scrollTarget == "number") ? scrollTarget : scrollTarget.offset().top + scrollPane.scrollTop() - parseInt(settings.offsetTop);
        scrollPane.animate({
            scrollTop: scrollY
        }, parseInt(settings.duration), settings.easing, function() {
            if (typeof callback == 'function') {
                callback.call(this);
            }
        });
    });
};


// Global Methods
// ------------------------------------------------------------------------

function asset(url)
{
    var protocol = pm.Constants.PROTOCOL;

    if (protocol.length > 0) {
        url = url.replace('http://', protocol + '://');
    }

    return url;
}

function navigate(url)
{
    if (pm.Flags.useRouting) {
        // update current states
        history.replaceState(
            _.extend(history.state || {}, {
                scrollTop: document.body.scrollTop || $(document).scrollTop()
            }),
            document.title,
            window.location
        );

        if (location.hostname) {
            url = url.replace(config.BASE_URL + '/', '');
            url = url.replace(location.hostname + '/', '');
        }
        url = url.replace('http:', '');
        url = url.replace('https:', '');
        url = url.replace(/\/$/, '');

        // navigate to new url
        Backbone.history.navigate( url, {
            trigger: true
        });
    }
    // else if (ignoreRoutes) {
    else if (typeof url == 'string') {
        $('html').addClass('loading-page');

        window.location = url;
    }
}

function refresh()
{
    var url = window.location.href;
        url = url.replace('http:', '');
        url = url.replace('https:', '');

    Backbone.history.fragment = null;
    Backbone.history.navigate( url.replace(config.BASE_URL + '/', ''), { trigger: true } );
}

function debugState()
{
    var i;

    for (i in pm.State) {
        console.log("[State] " + i + " - ", pm.State[i]);
    }
}

function lineDistance( point1, point2 )
{
    var xs = 0;
    var ys = 0;

    xs = point2.x - point1.x;
    xs = xs * xs;

    ys = point2.y - point1.y;
    ys = ys * ys;

    return Math.sqrt( xs + ys );
}

function loading() {
    $('body').addClass('loading');
}

function notloading() {
    $('body').removeClass('loading');
}

if (!console['color']) {
    console.color = console.log;
}

window.requestAnimFrame = (function(){
  return  window.requestAnimationFrame       ||
          window.webkitRequestAnimationFrame ||
          window.mozRequestAnimationFrame    ||
          function( callback ){
            window.setTimeout(callback, 1000 / 60);
          };
})();


// Windows Fixes
// -----------------------------------------------------------------------

if (navigator.userAgent.match(/IEMobile\/10\.0/)) {
    var msViewportStyle = document.createElement("style");
    msViewportStyle.appendChild(
        document.createTextNode(
            "@-ms-viewport{width:auto!important}"
        )
    );
    document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
}


;(function(namespace) {
    'use strict';

    var Events    = namespace.Events,
        Colors    = namespace.Colors,
        Constants = namespace.Constants;

    namespace.Tracking = {

        // vars
        index   : 0,
        category: null,
        queue   : [],

        add: function(category, action, value) {
            if (window['_gaq']) {
                // log
                console.color("[Tracking] " + category + " | " + action + " = " + value, Colors.TRACKING);

                // track
                _gaq.push(['_trackEvent', category, action, '' + value]);
            }
            else {
                console.warn("[Tracking] Tracking for _gaq could not be found.");
            }

            if (window['_paq']) {
                _paq.push(['trackEvent', category, action, '' + value]);
            }
            else {
                console.warn("[Tracking] Tracking for _paq could not be found.");
            }
        }

    };

    _.extend(namespace.Tracking, Backbone.Events);

})(window.pm || (window.pm = {}));

;(function(namespace) {
    'use strict';

    var UA               = navigator.userAgent,
        isIFrame         = window !== window.top,
        isFile           = location.protocol.indexOf('file') > -1,
        isLocal          = /dev./.test(location.hostname) || isFile,
        isStaging        = /staging/.test(location.hostname),
        isIOS            = /ip(hone|od|ad)/i.test(UA),
        isiPhone         = /ip(hone)/i.test(UA),
        isMobile         = /android|webos|iphone|ipad|ipod|blackberry|iemobile|opera mini/i.test(navigator.userAgent.toLowerCase()),
        isAndroid        = /android/i.test(UA),
        isAndroidBrowser = /android (?!.*(chrome|kindle))/i.test(UA),
        isChrome         = /chrome/i.test(UA) && !isAndroidBrowser,
        isWindows        = /windows/i.test(UA),
        isIE             = /msie[0-9.; ]+windows/i.test(UA),
        isIE9            = /msie 9/i.test(UA),
        isFirefox        = /firefox/i.test(UA),
        isSafari         = /safari/i.test(UA) && !/chrome/i.test(UA),
        isSafari5        = /version\/5\..+ safari/i.test(UA),
        isSafariMac      = isSafari && !isWindows && !isIOS,
        isSafariWin      = isWindows && isSafari,
        isTablet         = Modernizr.touch && !isWindows,
        isDebug          = window.DEBUG_MODE,
        ieVersion        = UA.match(/msie\s?([0-9]+)/i),
        firefoxVersion   = UA.match(/firefox\/([0-9]+)/i),
        safariVersion    = UA.match(/version\/([0-9]+)/i),
        hasPushState     = !!window.history && !!window.history.pushState,

        Colors = namespace.Colors = {
            ACTION       : { background: "#c39",    color: "#fff" },
            CAST         : { background: "#64056d", color: "#d6a2f4" },
            CRITICAL     : { background: "#f00",    color: "#fff" },
            IMPORTANT    : { background: "#dcf9dd", color: "#4e8e4e" },
            DEBUG        : { background: "#0E5342", color: "#93d9c7" },
            DEFER        : { background: "#f4f5cb", color: "#b4ba09" },
            LIST         : { background: "#e2eea9", color: "#708410" },
            LOADING      : { background: "#2099cd", color: "#fff" },
            PAGE         : { background: "#206bb7", color: "#cedff0" },
            PROGRESS     : { background: "#2099cd", color: "#ddd" },
            NAV          : { background: "#9cf",    color: "#333" },
            SEMI_CRITICAL: { background: "#f66",    color: "#eee" },
            SOCIAL       : { background: "#c3f1c2", color: "#357733" },
            SOUND        : { background: "#003300", color: "#66FF66" },
            TRACKING     : { background: "#c3f1c2", color: "#357733" },
            VIEW         : { background: "#fce6bc", color: "#b5862b" },
            VIDEO        : { background: "#00587e", color: "#fff" },
            VIDEO_ACTION : { background: "#00587e", color: "#ccc" },
            WARN         : { background: "#f8ea6c", color: "#9c6d1b" },

            WHITE : 0xffffff,
            BLUE  : 0x41c4d8,
            PINK  : 0xec9698,
            GREEN : 0x8ac635,
            RED   : 0xeb267a,
            YELLOW: 0xfcce00
        },

        Constants  = namespace.Constants = {
            ANIMATION_DURATION   : 250,
            API_URL              : config.API_URL        || "//dev.api.chalkysticks.com/v1",
            SOCKET_URL           : config.SOCKET_URL     || "//localhost:5002",
            USERSOCKET_URL       : config.USERSOCKET_URL || "//localhost:5003",
            IMAGE_HOST           : "",
            REQUIRE_AUTH         : true,
            CONTENT_PER_PAGE     : 15,
            PROTOCOL             : location.protocol.toString().replace(/[^htps]/g, '') || "https",

            BEACON_DURATION      : 3 * 60,
            BEACON_DISTANCE      : 5,
            START                : "start",
            STOP                 : "stop",
            ONESIGNAL_ID         : "72dc6874-8457-4554-92b5-fad100b0f9f1",
            GOOGLE_PROJECT_NUMBER: "355075788817"
        },

        Events = namespace.Events = {
            ADD            : 'add',
            ADD_NEXT       : 'add:next',
            ADD_PREVIOUS   : 'add:previous',
            ANIMATION_START: 'animation:start',
            ANIMATION_END  : 'animation:end',
            BACK           : 'back',
            BLUR           : 'blur',
            CLICK          : 'click',
            COMPLETE       : 'complete',
            EMPTY          : 'empty',
            ERROR          : 'error',
            FOCUS          : 'focus',
            GEO            : 'geo',
            GET_GEO        : 'geo:get',
            MENU_CLOSE     : 'menu:close',
            MENU_OPEN      : 'menu:open',
            MOUSE_DOWN     : 'mousedown',
            MOUSE_IDLE     : 'mouseidle',
            MOUSE_MOVE     : 'mousemove',
            MOUSE_OUT      : 'mouseout',
            MOUSE_OVER     : 'mouseover',
            MOUSE_UP       : 'mouseup',
            NAV            : 'nav',
            NEXT           : 'next',
            PROGRESS       : 'progress',
            REMOVE         : 'remove',
            RESUME         : 'resume',
            RESIZE         : 'resize',
            SCROLL         : 'scroll',
            SUCCESS        : 'success',
            TAB_UNFOCUSED  : 'tab:unfocused',
            TAB_FOCUSED    : 'tab:focused',
            TRIGGER        : 'trigger',
            WINDOW_RESIZE  : 'window:resize',


            // Backbone
            // -----------------------

            FETCH_DATA   : 'fetch:data',
            FETCH_ERROR  : 'fetch:error',
            FETCH_SUCCESS: 'fetch:success',


            // Player Specific
            // -----------------------
            PLAYER_PAUSE: 'player:pause',
            PLAYER_PLAY : 'player:play',
            PLAYER_STATE: 'player:state',


            // App Specific
            // --------------------------
            DECLARE_WINNER: 'winner',
            SEND_TO_B_SIDE: 'sendtobside',
            BEACON_START : 'beacon:start',
            BEACON_STOP  : 'beacon:stop',
            LOGIN        : 'login',

            API_READY      : 'api:ready',
            FINISHED       : 'finished',
            HALF_WAY       : 'halfway',
            LAST_2_SECONDS : 'last2seconds',
            LAST_5_SECONDS : 'last5seconds',
            LAST_10_SECONDS: 'last10seconds',
            LAST_PAGE      : 'page:last',
            LOADING        : 'loading',
            NEXT_EMPTY     : 'next:empty',
            PAUSE          : 'pause',
            PAUSED         : 'paused',
            PLAY           : 'play',
            PLAYPAUSE      : 'play-pause',
            PREVIOUS       : 'previous',
            PREVIOUS_EMPTY : 'previous:empty',
            SEEK           : 'seek',
            UNLOAD         : 'unload'

        },

        Flags = namespace.Flags = {
            isFile          : isFile,
            isMobile        : location.hostname == "m.chalkysticks.com" || isMobile,
            isLocal         : isLocal,
            isStaging       : isStaging,
            isIOS           : isIOS,
            isiPhone        : isiPhone,
            isAndroid       : isAndroid,
            isAndroidBrowser: isAndroidBrowser,
            isWebkit        : isSafari || isChrome,
            isChrome        : isChrome,
            isWindows       : isWindows,
            isIE            : isIE,
            isIE9           : isIE9,
            isFirefox       : isFirefox,
            isSafari        : isSafari,
            isTablet        : isTablet,
            isDebug         : isDebug,

            isMQStandard    : window.innerWidth >= 620 && window.innerWidth <= 1700,
            isMQPhone       : window.innerWidth < 620,
            isMQLarge       : window.innerWidth > 1700,

            hasLocalStorage : false,

            autoLogin     : false,
            useGoogle     : true,
            useRouting    : true && hasPushState,
            useTransitions: false, // isWindows
            useSockets    : location.host.indexOf("dev.") < 0
        },

        Keys = namespace.Keys = {
            RETURN: 13,
            SHIFT : 16,
            SPACE : 32,
            ALT   : 18,
            CMD   : 91,
            CTRL  : 17,
            DOWN  : 40,
            ESCAPE: 27,
            LEFT  : 37,
            RIGHT : 39,
            UP    : 38,
            NUM_0 : 48,
            NUM_1 : 49,
            NUM_2 : 50,
            NUM_3 : 51,
            NUM_4 : 52,
            NUM_5 : 53,
            NUM_6 : 54,
            NUM_7 : 55,
            NUM_8 : 56,
            NUM_9 : 57,
            Z     : 90
        },

        State = namespace.State = {};


    // Evaluated Flags
    // ----------------------------------------------------------

    Flags.hasLocalStorage = (function isLocalStorageNameSupported() {
        var testKey = 'test', storage = window.sessionStorage;
        try {
            storage.setItem(testKey, '1');
            storage.removeItem(testKey);
            return true;
        } catch (error) {
            return false;
        }
    })();


    // Console
    // ----------------------------------------------------------

    var consoleStartTime = Date.now();

    console.color = function() {
        var aa      = Array.prototype.slice.apply(arguments);
        var options = aa.pop() || {};
        var output;
        var diff;

        diff = Date.now() - consoleStartTime; consoleStartTime = Date.now();
        aa[0]       = "%c " + aa[0] + " ";
        output      = aa.join(' ') + " - " + diff + "ms";
        aa          = [output, "background: " + options.background + "; color: " + options.color + ";"];

        console.log.apply(console, aa);
    };

    if (!Flags.isLocal && !Flags.isStaging) {
        // remove console logging
        $.extend(console, {
            color         : $.noop,
            debug         : $.noop,
            error         : $.noop,
            // info          : $.noop,
            log           : $.noop,
            // warn          : $.noop,
            dir           : $.noop,
            dirxml        : $.noop,
            table         : $.noop,
            trace         : $.noop,
            assert        : $.noop,
            count         : $.noop,
            markTimeline  : $.noop,
            profile       : $.noop,
            profileEnd    : $.noop,
            time          : $.noop,
            timeEnd       : $.noop,
            timeStamp     : $.noop,
            group         : $.noop,
            groupCollapsed: $.noop,
            groupEnd      : $.noop,
            clear         : $.noop
        })
    }

    _.extend(namespace, Backbone.Events, {
        Browser  : Modernizr,
        parent   : window.top,
        $html    : $('html'),
        $document: $(document),
        $window  : $(window),
        $body    : $(document.body),
        $main    : $('main'),
        app      : null,
        func     : { },

        preventDefault: function(e) {
            e.preventDefault();
            e.stopPropagation();
            return false;
        }
    });


    if (typeof document.hidden !== "undefined") {
        window.visibilitychange = "visibilitychange";
    }
    else if (typeof document.mozHidden !== "undefined") {
        window.visibilitychange = "mozvisibilitychange";
    }
    else if (typeof document.msHidden !== "undefined") {
        window.visibilitychange = "msvisibilitychange";
    }
    else if (typeof document.webkitHidden !== "undefined") {
        window.visibilitychange = "webkitvisibilitychange";
    }


    // Deferable Actions
    // ------------------------------------------------------

    function defer(callback, key) {
        var key = 'deferrable' + key;

        window.deferrable = window.deferrable || {};

        // immediate execute
        if (!key && namespace.app) {
            return callback();
        }

        // check key
        if (!key) key = Math.random();

        // create list, if not exists
        if (!window.deferrable[key]) window.deferrable[key] = [];

        // add to list
        window.deferrable[key].push(callback);
    };

    namespace.executeDefer = function executeDefer(key) {
        for (var i in window.deferrable) {
            // execute specific keys
            if (key) {
                window.deferrable['deferrable' + key].forEach(function(cb) { cb() });

                window.deferrable[key] = null;
                delete window.deferrable[key];
                break;
            }

            // execute all keys
            else {
                window.deferrable[i].forEach(function(cb) { cb() });
            }
        }

        // reset all
        window.deferrable = null;
    };

    _.templateSettings = {
        interpolate: /\[\[(.+?)\]\]/g
    };


    // Load
    // ----------------------------------------------------------

    if (Flags.isMobile) {
        $('html').addClass("is-mobile");
    }

    if (Flags.isIOS) {
        $('html').addClass("is-ios");

        if (/OS 7/.test(navigator.userAgent)) {
            $('html').addClass("is-ios-7");
        }
    }

})(window.pm || (window.pm = {}));

Date.prototype.stdTimezoneOffset = function() {
    var jan = new Date(this.getFullYear(), 0, 1);
    var jul = new Date(this.getFullYear(), 6, 1);
    return Math.max(jan.getTimezoneOffset(), jul.getTimezoneOffset());
}

Date.prototype.dst = function() {
    return this.getTimezoneOffset() < this.stdTimezoneOffset();
}

function shuffle(a) {
    var j, x, i;
    for (i = a.length; i; i -= 1) {
        j = Math.floor(Math.random() * i);
        x = a[i - 1];
        a[i - 1] = a[j];
        a[j] = x;
    }
}

function goesInto(number) {
    var i = 0;

    while (number > 1) {
        number /= 2;
        i++;
    }

    return i;
}

function divideInto(number, times) {
    for ( var i = 0; i < times; i ++) {
        number /= 2;
    }

    return number;
}


function Remote(type, object) {
    var response, State = pm.State;

    type || (type = "Model");

    var getValue = function( model, object, prop ) {
        if (!(object && object[prop])) {
            return null;
        }

        return _.isFunction(object[prop]) ? object[prop].call(model) : object[prop];
    },
    templateSettings = {
        evaluate   : /\{\#([\s\S]+?)\}/g,
        interpolate: /\{([\s\S]+?)\}/g,
        escape     : /\{\%([\s\S]+?)\}/g
    };

    response = Backbone[type].extend({

        // variables
        _data   : null,
        _options: null,
        _xhr    : null,

        disableCache: false,

        urls: {

        },

        // Public Methods
        // ------------------------------------------------------------------

        initialize: function(content, options) {
            content || (content = {});
            options || (options = {});

            this._data || (this._data = {});
            this._options || (this._options = {});

            // opts
            this.count  = options.count;
            this.limit  = options.limit;
            this.page   = options.page;
            this.total  = options.total;
            this._links = options._links;

            Backbone[type].prototype.initialize.call(this, content, options);
        },

        abort: function() {
            this.isLoading() && this._xhr.abort();

            return this;
        },

        clearFetchData: function() {
            this._data = {};
        },

        getFetchData: function() {
            return this._data;
        },

        fetch: function(data, options) {
            // mk: @TODO init isn't getting called for some reason
            this._data || (this._data = {});
            this._options || (this._options = {});

            data    || (data = {});
            options || (options = {});

            // limit / page
            if (type == 'Collection') {
                data.page  = data.page || this.page;
                data.limit = data.limit || this.limit;
            }

            // used for prev / next / etc
            this._options = options;
            this._data    = _.extend(this._data, data);

            options.data = this._data;
            // options.cache = false;

            // exit anything else
            this.abort();

            // events
            this.trigger('will:fetch', this);

            return this._xhr = Backbone[type].prototype.fetch.call(this, $.extend(options, {
                success: _.bind(this._onFetchSuccess, this),
                error  : _.bind(this._onFetchError, this)
            }));
        },

        hasLoaded: function () {
            return this._xhr && this._xhr.state() == 'resolved';
        },

        isLoading: function () {
            return this._xhr && this._xhr.state() != 'resolved';
        },

        reset: function() {
            this.abort();

            return Backbone[type].prototype.reset.apply(this, arguments);
        },

        setFetchData: function(params) {
            params || (params = {});

            this._data || (this._data = {});
            this._data = _.extend(params, this._data);
        },

        setResponse: function(response) {
            this._response = response;
        },

        destroy: function(options) {
            options || (options = {});

            options.error   = this._error('destroy');
            options.success = this._success('destroy');

            return Backbone[type].prototype.destroy.call(this, options);
        },

        save: function(attributes, options) {
            options || (options = {});

            options.error   = this._error('save');
            options.success = this._success('save');

            return Backbone[type].prototype.save.call(this, attributes, options);
        },

        sync: function ( method, model, options ) {
            var opts    = _.clone(options),
                url     = this.renderURL( method, opts ),
                success = options.success,
                error   = options.error,
                self    = this;

            if ( !opts['url'] ) {
                opts.url = url;
            }

            opts.beforeSend = function (xhr) {
                var token = (State['get'] ? State.get('token') : null) || pm['TOKEN'];
                xhr.setRequestHeader('Authorization-API', "Bearer " + token);
            };

            opts.url = url.replace(/\/\/$/, '/');

            // no cache busting
            if (opts.url.indexOf("?") > 0) {
                opts.url += "&amp;cb=" + (pm.State.cbKey || Math.random());
            }
            else {
                opts.url += "?cb=" + (pm.State.cbKey || Math.random());
            }

            // fix https for dev
            if (/dev./.test(location.hostname)) {
                opts.url = opts.url.replace('https:', 'http:');
            }

            loading();

            opts.success = function ( resp, status, xhr ) {
                notloading();

                try {
                    success(resp, status, xhr);
                }
                catch (err) {
                    error(err);
                }
            };

            opts.error = function ( resp, status, xhr ) {
                notloading();

                try {
                    error(resp, status, xhr);
                }
                catch (err) {
                    error(err);
                }
            };

            return Backbone[type].prototype.sync.call( model, method, model, opts );
        },

        renderURL: function ( method, options ) {
            var urlString =  !_.isEmpty(this.urls) ? getValue(this, this.urls, method) : getValue(this, this, 'url');
                urlString = options['url'] || urlString;

            return _.template( urlString, _.extend({}, this, this.attributes, options), templateSettings );
        },


        // Event Handlers
        // -------------------------------------------------------------------

        _onFetchError: function(object, response) {
            // put on root
            object.error = response.error;
            object.status = response.status;
            object.setResponse(response);

            if (response.statusText == 'abort') {
                object.trigger('abort', object);
                object.trigger('fetch:abort', object);
            }
            else {
                object.trigger('error', object);
                object.trigger('fetch:error', object);
            }
        },

        _onFetchSuccess: function(object, response) {
            // put on root
            object.status = response.status;
            object.setResponse(response);

            if (response.data) {
                this.set(response.data, { silent: true });
            }

            object.trigger('success', object);
            object.trigger('fetch:success', object);
            object.trigger('fetch:data', object);
        },

        // for reset/save/etc
        _success: function(type) {
            var self = this;

            return function(model, response) {
                self.status = response.status;
                self.setResponse(response);

                self.trigger('success', self, response);

                if (response.data) {
                    self.set(response.data, { silent: true });

                    self.trigger(type + ':success', self, response);
                    self.trigger(type + ':data', self, response);
                }
                else {
                    self._error(type)(self, response);
                }
            }
        },

        _error: function(type) {
            var self = this;

            return function(model, response) {
                // put on root
                self.error = response.error;
                self.status = response.status;
                self.setResponse(response);

                if (response.statusText == 'abort') {
                    self.trigger('abort', self, response);
                    self.trigger(type + ':abort', self, response);
                }
                else {
                    self.trigger('error', self, response);
                    self.trigger(type + ':error', self, response);
                }
            }
        }

    });

    // Push down
    return response.extend(object || {});
};


;(function(namespace) {
    'use strict';

    // add scope for relationals
    namespace.Model_Base = Remote('Model', {

        model_map: { },

        initialize: function(options) {
            options || (options = {});

            // custom
            this.set('id', options.ID || this.id);

            // super
            Backbone.Model.prototype.initialize.call(this, options);
        },

        set: function() {
            var resp = Backbone.Model.prototype.set.apply(this, arguments),
                options = this.attributes;

            // model mapping
            _.each(this.model_map, function(modelName, key) {
                if (options[key]) {
                    var data = modelName.indexOf("Collection") > -1 ? options[key].data : options[key];

                    if (this[key] instanceof namespace[modelName]) {
                        // this[key].set(data);

                        // console.warn("ModelMap already exists for ", modelName, data);
                    }
                    else {
                        var model = new namespace[modelName](data);
                        this[key] = model;
                    }

                    // console.log( "Setting model mapping", modelName, data );
                    // this[key].parent = this;
                }
            }, this);

            return resp;
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Colors = namespace.Colors,
        Events = namespace.Events
    ;

    namespace.Collection_Base = Remote('Collection', {

        // pagination
        limit   : 10,
        page    : 1,
        total   : 0,
        page_max: 0,
        _links  : null,


        // Public Methods
        // -------------------------------------------------------------------

        next: function(data, options) {
            var fetch, self = this;

            data == undefined    && (data = this._data);
            options == undefined && (options = this._options);

            // no more
            if (this.lastPage) {
                console.color("[Collection] We cannot go any further.", Colors.CRITICAL);

                return false;
            }

            if (!data.limit) {
                data.limit = this.limit || 15;
            }

            data.page  = ++this.page || ++data.page || 1;

            fetch = this.fetch(data, options);

            if (fetch && fetch.then) {
                fetch.then(function(data, status, xhr) {
                    if (
                        (!data) ||
                        (data && !data.data) ||
                        (data && data.data && data.data.length < 1) ||
                        (data && data.data && data.data.length < self._data.limit)
                        ) {
                        self.lastPage = true;

                        // warn
                        console.color("[Collection] We just fetched the last page.", Colors.CRITICAL);

                        // broadcast
                        self.trigger(Events.LAST_PAGE);
                    }

                });
            }

            return fetch;
        },

        comparator: function(item) {
            return item.get(this.sort_key);
        },

        sortByField: function(fieldName) {
            this.sort_key = fieldName;
            this.sort();
            this.sort_key = 'id';

            return this;
        },

        isEmpty: function() {
            // return this.hasLoaded() && this.length == 0;
            return !this.hasLoaded() || (this.hasLoaded() && this.length == 0);
        }

    });

})(window.pm || (window.pm = {}));

;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Events    = namespace.Events,
        Flags     = namespace.Flags,
        State     = namespace.State;

    namespace.View_Base = Backbone.View.extend({

        // <Const>
        _animate_state: Events.ANIMATION_END,

        // <Boolean> enable tabs
        enableTabs: false,

        // <Object> View manager
        views: null,

        // <Boolean> For whether or not the render has happened
        rendered: false,

        // <Object> View UI of tabs manager
        tabs: null,

        // <Object> Template data to combine
        templateData: null,


        initialize: function(options) {
            options || (options = {});

            // bind
            _.bindAll(this, '_onAnimateIn', '_onAnimateOut');

            // merge options
            _.extend(this, options);

            // template data
            this.templateData = {};

            // views
            this.views = new namespace.View_Views(this);
            this.$v    = _.bind(function(x) {
                return this.views.get(x);
            }, this);

            // parent
            this.parent = options.parent || window;

            // template
            if (this.templateName) {
                this.template = $('#' + this.templateName).html();
                this.twig     = twig({ data: this.template });
            }

            if (this.template && (this.isPage || this.autoRender)) {
                this.$el.html( this.twig.render() );
            }

            if (this.enableTabs) {
                this.tabs = new namespace.View_UI_Tabs({
                    el: this.$el
                });
            }

            // events
            // if (Flags.isTablet || Flags.isMobile) {
            //     this.convertToTouch();
            // }
        },

        attachEvents: function() {
            this.detachEvents();
            this.delegateEvents(this.events);

            this.views.execAll('attachEvents');
        },

        detachEvents: function() {
            this.views.execAll('detachEvents');
            this.undelegateEvents();
        },

        convertToTouch: function() {
            _.each(this.events, function(value, key) {
                if (key.indexOf("click") > -1) {
                    delete this.events[key];
                    key = key.replace("click", "tap");
                    this.events[key] = value;
                }
            }, this);
        },

        animateIn: function(options) {
            options || (options = {});

            options.duration = !isNaN(options.duration) ? options.duration : Constants.ANIMATION_DURATION;

            if (this.isHidden()) {
                this.animateOut({ duration: 0 });
            }

            this._onAnimateStart();

            this.$el
                .stop()
                .delay(options.delay || 0)
                .slideDown(options.duration, _.bind(this._onAnimateIn, this));

            return this;
        },

        animateOut: function(options) {
            options || (options = {});

            options.duration = !isNaN(options.duration) ? options.duration : Constants.ANIMATION_DURATION;

            this._onAnimateStart();

            this.$el
                .stop()
                .delay(options.delay || 0)
                .slideUp(options.duration, _.bind(this._onAnimateOut, this));

            return this;
        },

        animateToggle: function(options) {
            if (this._animate_state === Constants.ANIMATE_IN) {
                this.animateOut(options);
            }
            else if (this._animate_state === Constants.ANIMATE_OUT) {
                this.animateIn(options);
            }

            return this;
        },

        hide: function() {
            // this.$el.css('display', '').addClass('hide');
            this.$el.hide();

            return this;
        },

        show: function() {
            // this.$el.css('display', '').removeClass('hide');
            this.$el.show();

            return this;
        },

        fadeIn: function() {
            this.$el
                .removeClass('hide')
                .hide()
                .fadeIn();

            return this;
        },

        template: function(params) {
            return namespace.func.template(this.templateName, params || {});
        },

        decode: function(object, attr_key, val_key) {
            attr_key = attr_key || 'name';
            val_key  = val_key || 'val';

            _.each(object, function(value, key) {
                this.$el.find("[" + attr_key + "=" + key + "]")[val_key](value);
            }, this);
        },

        encode: function(attr_key, val_key) {
            var hash = {};

            attr_key = attr_key || 'name';
            val_key  = val_key || 'val';

            this.$el.find('*[' + attr_key + ']').each(function(e) {
                hash[$(this).prop(attr_key)] = $(this)[val_key]();
            });

            return hash;
        },

        reattachEvents: function() {
            this.detachEvents();
            this.attachEvents();
        },

        reset: function() {
            return this;
        },

        lock: function() {
            this.locked = true;
        },

        unlock: function() {
            this.locked = false;
        },

        setState: function(type) {
            this.$el.addClass('state-' + type);
        },

        unsetState: function(type) {
            this.$el.removeClass('state-' + type);
        },

        unsetAllStates: function(type) {
            this.$el[0].className = this.$el[0].className.replace(/\bstate\-.*?\b/g, '');
        },

        render: function(data) {
            Backbone.View.prototype.render.call(this);

            // state
            this.rendered = true;

            // data
            data   || (data = {});
            config || (config = {});

            // special
            if (this.model) data.model = this.model;
            if (this.collection) data.collection = this.collection;

            data.isLoggedIn   = State['isLoggedIn'] ? State.isLoggedIn() : null;
            data.user         = window['user'] || config['USER'] || { };
            data.userId       = data.user.id || 0;
            data.version      = config.VERSION;
            data.timezoneAbbr = (new Date()).getTimezone();

            data = _.extend(data, this.templateData);

            // render template
            this.twig && this.$el.html( this.twig.render(data) );

            // do tabs
            if (this.tabs) {
                this.tabs.render();
            }

            return this;
        },

        // undelegateEvents: function() {
        //     _.each(this.events, function(value, key) {

        //         key = key.replace("tap", "click");
        //         this.$el.off(key);

        //         key = key.replace("click", "tap");
        //         this.$el.off(key);

        //     }, this);
        // },

        // Getters
        // ----------------------------------------------------------

        hasRendered: function() {
            return !!this.rendered;
        },

        isBottomVisible: function() {
            var position = this.$el.position();

            if (position && position.top) {
                return this.$el.outerHeight() + this.$el.position().top < window.innerHeight + $(window).scrollTop();
            }
            else {
                console.log(this.$el, " cannot get position");
            }
        },

        isHidden: function() {
            return !!this.$el.hasClass('hide');
        },

        isLocked: function() {
            return this.locked === true;
        },


        // Internal
        // -------------------------------------------------------------

        _setAnimateStart: function() {
            this._animate_state = Constants.ANIMATE_TRANSITION;
        },

        _setAnimateIn: function() {
            this._animate_state = Constants.ANIMATE_IN;
        },

        _setAnimateOut: function() {
            this._animate_state = Constants.ANIMATE_OUT;
        },


        // Event Handlers
        // -------------------------------------------------------------

        _onAnimateStart: function() {
            this._setAnimateStart();

            this.trigger(Events.ANIMATING);

            // unhide this block
            this.show();
        },

        _onAnimateIn: function() {
            this._setAnimateIn();

            // state
            this.$el.addClass('state-animated-in');

            this.trigger(Events.ANIMATE_IN);
        },

        _onAnimateOut: function() {
            this._setAnimateOut();

            // state
            this.$el.removeClass('state-animated-in');

            this.trigger(Events.ANIMATE_OUT);
        }

    });

})(window.pm || (window.pm = {}));
/**
 * @package ShortOfTheWeek
 * @authors Matt Kenefick <matt@polymermallard.com>
 * @date    2014-06-15 00:00:00
 * @version 0.0.1
 */

;(function(namespace) {
    'use strict';

    var Events = namespace.Events,
        Colors = namespace.Colors,
        Flags  = namespace.Flags;

    namespace.Page_Base = namespace.View_Base.extend({

        // <Array> Matches objects in URL
        urlObjects: null,

        // <String> Override pattern to match for URL Objects
        urlPattern: "",


        initialize: function(options) {
            options || (options = {});

            // bind
            _.bindAll(this, 'onClickMenuToggle', 'onData', 'onClickReadMore');

            // get url objects
            this.urlObjects = location.pathname.match(this.urlPattern);

            // super
            namespace.View_Base.prototype.initialize.call(this, options);
        },

        attachEvents: function() {
            // super
            namespace.View_Base.prototype.attachEvents.call(this);

            $('.action-menu').on('click', this.onClickMenuToggle);
            $('.action-back-page a').on('click', this.onClickBack);
            $('body').on('click', '.action-read-more', this.onClickReadMore);
        },

        detachEvents: function() {
            // super
            namespace.View_Base.prototype.detachEvents.call(this);

            $('.action-menu').off('click', this.onClickMenuToggle);
            $('.action-back-page a').off('click', this.onClickBack);
            $('body').off('click', '.action-read-more', this.onClickReadMore);
        },


        // Animation
        // -------------------------------------------------------------------

        animateIn: function() {
            // state
            this.$el.addClass('state-animated-in');

            return Flags.useTransitions ? this.$el.fadeIn() : this.$el.show();
        },

        animateOut: function() {
            // state
            this.$el.removeClass('state-animated-in');

            return Flags.useTransitions ? this.$el.fadeOut() : this.$el.hide();
        },

        render: function() {
            // super
            namespace.View_Base.prototype.render.apply(this, arguments);

            // remove old page classes
            namespace.$body[0].className = namespace.$body[0].className.replace(/\bpg-\-.*?\b/g, '');

            // body
            namespace.$body.addClass("rendered");
            namespace.$body.addClass("pg-" + this.name);

            // history
            if ($('footer.requires-login').length >= 1) {
                $('body').addClass('has-footer-via-login');

                $('.scrollable')
                    .addClass('scrollable-with-footer')
                    .removeClass('scrollable');
            }
            else if ( $('footer').length >= 1) {
                $('body').addClass('has-footer');

                $('.scrollable')
                    .addClass('scrollable-with-footer')
                    .removeClass('scrollable');
            }
        },


        // Event Handlers
        // -------------------------------------------------------------------

        onClickBack: function(e) {
            e.preventDefault();

            window.history.back();
        },

        onClickMenuToggle: function(e) {
            e.preventDefault();

            $('body').toggleClass("menu-open");
        },

        onClickReadMore: function(e) {
            e.preventDefault();

            var $el = $(e.currentTarget);

            $el.next('.read-more').toggle();
        },

        onData: function(response, status, xhr) {
            this.render();
        },

        onAnimatedIn: function() {
            // called from router

            // check scroll state
            if (history.state && history.state.scrollTop) {
                // log
                this.color("Setting scroll position to " + history.state.scrollTop);
            }
        },

        onAnimatedOut: function() {
            // called from router
        }

    });

})(window.pm || (window.pm = {}));
/**
 * @client  ChalkySticks
 * @authors Matt Kenefick (matt@polymermallard.com)
 * @date    2016-01-01
 */

;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Events    = namespace.Events;

    namespace.View_Views = function(view) {
        this._parent = view;
        this._byId   = {};
        this._views  = [];
    };

    namespace.View_Views.prototype = {
        length: 0,

        _parent: false,
        _byId  : false,
        _views : false,

        add: function(view, name) {
            name || (name = 'model' in view ? view.model.cid : view.cid);

            if (!view) {
                throw 'add requires a view';
            }
            else if (this.has(name)) {
                throw name + ' is already a sub-view';
            }

            view._viewKey = name;

            this._views.push(view);
            this._byId[name] = view;

            // assign parent view
            if (!view.parent) {
                view.parent = this._parent;
            }

            this.length++;

            return this;
        },

        has: function(nameOrModel) {
            return this._getModelCidOrName(nameOrModel) in this._byId;
        },

        _get: function(nameOrModel) {
            var name = this._getModelCidOrName(nameOrModel);
            if (this.has(name)) {
                return this._byId[name];
            }
        },

        get: function(name) {
            var obj, parts;

            // get descending children
            if (name.indexOf(' ') > -1) {
                parts = name.split(' ');
                name  = parts[0];
                obj   = this._get(name);
                parts.shift();

                return obj.views.get(parts.join(' '));
            }

            return this._get(name);
        },

        at: function(index) {
            return this._views[index];
        },

        remove: function(names) {
            names  || (names = []);
            names = _(names).isString() ? [names] : names;

            // iterate through list of view names
            _(names).each(function(name) {
                // make sure view exists
                if (this.has(name)) {
                    // call remove first
                    this._byId[name].remove();

                    // get index
                    var index = _.indexOf(this._views, this._byId[name]);

                    // delete hash
                    this._byId[name] = void 0;
                    delete this._byId[name];

                    // delete array
                    this._views.splice(index, 1);

                    // update length
                    this.length--;
                }
            }, this);

            return this;
        },

        reset: function(options) {
            options || (options = {});
            var except = options.except || [];
            except = _(except).isString() ? [except] : except;

            var names = [];

            _.each(this._byId, function(view, name) {
                if (_.indexOf(except, name) === -1) {
                    names.push(name);
                }
            });

            return this.remove(names);
        },

        debug: function() {
            var object = [];

            this.each(function(view) {
                object.push({
                    cid: view.cid,
                    key: view._viewKey,
                    name: view.name
                });
            });

            console.table(object);
        },

        invoke: function() {
            return _.invoke.apply(_, [this._views].concat(_.toArray(arguments)));
        },

        indexOf: function() {
            return _.indexOf.apply(_, [this._views].concat(_.toArray(arguments)));
        },

        indexOfElement: function($el) {
            for (var i in this._views) {
                if (this.at(i).$el.get(0) == $el) {
                    return i;
                }
            }
        },

        each: function() {
            return _.each.apply(_, [this._views].concat(_.toArray(arguments)));
        },

        every: function() {
            return _.all.apply(_, [this._views].concat(_.toArray(arguments)));
        },

        execAll: function(methodName, except) {
            except || (except = []);
            var args = _.toArray(arguments);
                args.shift();

            _.each(this._views, function(view, index) {
                if (!_(except).contains(view._viewName)) {
                    view[methodName].apply(view, args);
                }
            }, this);
        },

        _getModelCidOrName: function(nameOrModel) {
            return _(nameOrModel).isObject() ? nameOrModel.cid : nameOrModel;
        }
    };

})(window.pm || (window.pm = {}));

/**
 * @package ChalkySticks
 * @authors Matt Kenefick <matt@polymermallard.com>
 */

 ;(function(namespace) {
    'use strict';

    var Constants = pm.Constants,
        Colors    = pm.Colors,
        Events    = pm.Events,
        State     = pm.State
    ;

    window.Utility_Form = {


        // Public Methods
        // -------------------------------------------------------------------

        submit: function($form, params) {
            params || (params = {});

            var data   = new FormData($form.get(0)),
                action = $form.attr('action'),
                url    = Constants.API_URL + action,
                method = $form.attr('method').trim();

            // set loading
            $form.find('.dimmer').addClass('active');

            // if we need to process
            if (params.process) {
                data = $form.serialize();
            }

            // use form data
            else {

            }

            // modify data
            params.data && params.data(data);

            // save
            $.ajax({
                type       : params.type || method,
                url        : url,
                data       : data,
                dataType   : 'json',
                crossDomain: true,
                // "throws"   : true,
                encode     : params.process || false,
                processData: params.process || false,
                contentType: params.isFile ? false : "application/x-www-form-urlencoded; charset=UTF-8",
                beforeSend : function(request) {
                    request.setRequestHeader("Authorization-API", "Bearer " + State.token);
                },
            })
            .done(params.success || $.noop)
            .fail(params.error || $.noop)
            .always(function() {
                $form.find('.dimmer').removeClass('active');
            });
        }

    };

})(window.pm || (window.pm = {}));

/**
 * @package ChalkySticks
 * @authors Matt Kenefick <matt@polymermallard.com>
 */

 ;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Colors    = namespace.Colors,
        Events    = namespace.Events,
        Flags     = namespace.Flags,
        Settings  = namespace.Settings,
        State     = namespace.State
    ;

    window.URL = window.Utility_URL = {

        // <Bool> Whether or not we should bust cache on the URL
        bustCache: true,


        // Public Methods
        // -------------------------------------------------------------------

        go: function(url) {
            var url;

            url = config.BASE_URL.length ? url.replace(config.BASE_URL + '/', '') : url;

            Backbone.history.navigate( url, { trigger: true } );
        },

        base: function(url) {
            url || (url = '');

            return this.filter(config.BASE_URL + url);
        },

        api: function(url) {
            url || (url = '');

            return this.filter(Constants.API_URL + url);
        },


        // Filters
        // -------------------------------------------------------------------

        filter: function(url) {
            if (this.bustCache) {
                url = this.filter_bust(url);
            }

            return url;
        },

        filter_bust: function(url) {
            url += "?random=" + Math.random();

            return url;
        }

    };

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Accomplishments = namespace.Model_Base.extend({

        // public
        id         : null,
        icon_url   : null,
        banner_url : null,
        description: null,

        // api
        url: Constants.API_URL + "/accomplishments/{id}/",


        // Getters
        // -------------------------------------------------------------

        getIconURL: function() {
            return asset( this.get('icon_url') );
        },

        getBannerURL: function() {
            return asset( this.get('banner_url') );
        },

        getDescription: function() {
            return asset( this.get('description') );
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags,
        State     = namespace.State;

    namespace.Model_Beacons = namespace.Model_Base.extend({

        // public
        id: null,
        lat: null,
        lon: null,
        distance: null,
        time_ago: null,
        status: null,
        keepalive: null,
        created_at: null,
        updated_at: null,

        // models
        user: null,

        // api
        url: Constants.API_URL + "/beacons/{id}/",

        // maps
        model_map: {
            'user': 'Model_Users'
        },


        // Custom Fetch
        // -------------------------------------------------------------

        search: function(category) {
            return this.fetch(
                { category: category },
                {
                    url: Constants.API_URL + "/beacons/"
                }
            );
        },

        stopBeacon: function() {
            var self = this;

            return $.ajax({
                url    : Constants.API_URL + "/beacons/",
                type   : "DELETE",
                headers: {
                    'Authorization-API': "Bearer " + State.get('token')
                }
            })
            .done(function() {
                State.updateCacheKey();
            });
        },


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getDistance: function(round) {
            return round ? parseFloat(this.get('distance')).toFixed(round) : this.get('distance');
        },

        getTimeAgo: function(round) {
            return this.get('time_ago');
        },

        getKeepAlive: function() {
            return this.get('keepalive');
        },

        getLatitude: function() {
            return this.get('lat');
        },

        getLongitude: function() {
            return this.get('lon');
        },

        getStatus: function() {
            return this.get('status');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Brackets = namespace.Model_Base.extend({

        // public
        id                : null,
        tournamententry_id: null,
        side              : "a",
        order             : null,
        round             : null,
        table             : null,
        created_at        : null,
        updated_at        : null,

        // api
        url: Constants.API_URL + "/brackets/{id}/",


        // Getters
        // -------------------------------------------------------------

        getRound: function() {
            return this.get('round');
        },

        getTable: function() {
            return this.get('table');
        },

        getTournamentEntryID: function() {
            return parseFloat(this.get('tournamententry_id'));
        },

        getOrder: function() {
            return this.get('order');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Content = namespace.Model_Base.extend({

        // public
        id        : null,
        title     : null,
        content   : null,
        media_type: null,
        media_url : null,
        created_at: null,
        updated_at: null,

        // api
        url: Constants.API_URL + "/content/{id}/",


        // Getters
        // -------------------------------------------------------------

        getContent: function() {
            return this.get('content');
        },

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getEmbeddable: function() {
            if (this.hasImage()) {
                return '<img src="' + this.getMediaURL() + '">'
            }
            else if (this.hasVideo()) {
                return '<iframe width="560" height="315" frameborder="0" allowfullscreen src="' + this.getMediaURL() + '"></iframe>'
            }
        },

        getMediaURL: function() {
            var url = this.get('media_url'),
                protocol = Constants.PROTOCOL;

            if (protocol.length > 0) {
                url = url.replace('http://', protocol + '://');
            }

            return url;
        },

        getPreview: function() {
            return this.getContent().substr(0, 50) + "...";
        },

        getTitle: function(amount) {
            return this.get('title');
        },

        getType: function() {
            return this.get('media_type');
        },

        getThumbnailURL: function() {
            var url = this.getMediaURL(),
                id;

            if (this.get('thumbnail_url')) {
                return this.get('thumbnail_url');
            }
            else if (this.hasVideo() && url.indexOf("youtube.com")) {
                id = url.match(/(?:https?:\/{2})?(?:w{3}\.)?youtu(?:be)?\.(?:com|be)(?:\/watch\?v=|\/embed\/|\/)([^\s&]+)/);
                id = id[1];

                return asset("http://img.youtube.com/vi/" + id + "/0.jpg");
            }
            else {
                return url;
            }

            return "";
        },

        getURL: function(segment) {
            var type = segment || (this.hasImage() ? "news" : "videos");

            if (this.getThumbnailURL().indexOf("pad.chalkysticks.com/image/") > 0) {
                type = "poolpad";
            }

            return "/" + type + "/" + this.id;
        },

        hasImage: function() {
            return this.get('media_type') == 'image';
        },

        hasVideo: function() {
            return this.get('media_type') == 'video';
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Feed = namespace.Model_Base.extend({

        // public
        id           : null,
        html_message : null,
        plain_message: null,
        type         : null,
        lat          : null,
        lon          : null,
        distaince    : null,
        created_at   : null,
        updated_at   : null,

        // api
        url: Constants.API_URL + "/feed/{id}/",


        // Getters
        // -------------------------------------------------------------

        getDistance: function(round) {
            var distance = round ? parseFloat(this.get('distance')).toFixed(round) : this.get('distance');

            return isNaN(distance) ? "Unknown" : distance;
        },

        getDistanceFormatted: function(round) {
            var distance = round ? parseFloat(this.get('distance')).toFixed(round) : this.get('distance');

            return isNaN(distance) ? this.getCity() + ", " + this.getState() : distance + " mi";
        },

        getLatitude: function() {
            return this.get('lat');
        },

        getLongitude: function() {
            return this.get('lon');
        },

        getMessage: function() {
            return this.get('html_message');
        },

        getType: function() {
            return this.get('type');
        },

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getCreatedAtFromNow: function() {
            return moment( moment.utc(this.get('created_at')).toDate() ).fromNow();
        },

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Games = namespace.Model_Base.extend({

        // public
        id        : null,
        is_win    : null,
        is_loss   : null,
        created_at: null,
        updated_at: null,
        ended_at  : null,

        // models
        user1: null,
        user2: null,

        // api
        url: Constants.API_URL + "/games/{id}/",

        // maps
        model_map: {
            'user1': 'Model_Users',
            'user2': 'Model_Users'
        },


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getEndedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('ended_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('ended_at');
        },

        isWin: function() {
            return this.get('is_win');
        },

        isLoss: function() {
            return this.get('is_loss');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Matches = namespace.Model_Base.extend({

        // public
        id        : null,
        is_win    : null,
        is_loss   : null,
        created_at: null,
        updated_at: null,
        ended_at  : null,

        // api
        url: Constants.API_URL + "/matches/{id}/",


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getEndedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('ended_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('ended_at');
        },

        isWin: function() {
            return this.get('is_win');
        },

        isLoss: function() {
            return this.get('is_loss');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Media = namespace.Model_Base.extend({

        // public
        id        : null,
        type      : null,
        url       : null,
        created_at: null,
        updated_at: null,


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getURL: function() {
            return asset( this.get('url') );
        },

        isImage: function() {
            return this.get('type') == 'image';
        },

        isVideo: function() {
            return this.get('type') == 'video';
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags,
        State     = namespace.State;

    namespace.Model_Messages = namespace.Model_Base.extend({

        // public
        id        : null,
        user_id   : null,
        body      : null,
        created_at: null,
        updated_at: null,


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        isMe: function() {
            return State.user && State.user.id == this.getUserID();
        },

        getUserID: function() {
            return this.get('user_id');
        },

        getUser: function() {
            return false;
        },

        getBody: function(truncate) {
            var body = this.get('body');

            if (truncate && !isNaN(truncate)) {
                return body.substring(0, truncate) + (body.length > truncate - 3 ? "..." : "");
            }
            else {
                return body;
            }
        },

        getValue: function() {
            return this.get('value');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Meta = namespace.Model_Base.extend({

        // public
        id   : null,
        group: null,
        key  : null,
        value: null,


        // Getters
        // -------------------------------------------------------------

        getGroup: function() {
            return this.get('group');
        },

        getKey: function() {
            return this.get('key');
        },

        getValue: function() {
            return this.get('value');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Nights = namespace.Model_Base.extend({

        // public
        id        : null,
        created_at: null,
        updated_at: null,

        // collection
        matches: null,

        // api
        url: Constants.API_URL + "/nights/{id}/",

        // maps
        model_map: {
            'matches': 'Collection_Matches'
        },


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Participants = namespace.Model_Base.extend({

        // public
        id        : null,
        last_read : null,
        created_at: null,
        updated_at: null,

        // model
        user: null,

        // maps
        model_map: {
            'user': 'Model_Users'
        },


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getLastRead: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('last_read')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('last_read');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Payments = namespace.Model_Base.extend({

        // public
        id         : null,
        type       : null,
        type_id    : null,
        cc_name    : null,
        cc_digits  : null,
        cc_cvc     : null,
        cc_month   : null,
        cc_year    : null,
        notes      : null,
        created_at : null,
        updated_at : null,

        // model
        paymentOption: null,

        // api
        url: Constants.API_URL + "/payments/{id}/",


        // Getters
        // -------------------------------------------------------------

        getType: function() {
            return this.get('type');
        },

        getTypeId: function() {
            return this.get('type_id');
        },

        getDigits: function() {
            return this.get('cc_digits');
        },

        getName: function() {
            return this.get('cc_name');
        },

        getCVC: function() {
            return this.get('cc_cvc');
        },

        getMonth: function() {
            return this.get('cc_month');
        },

        getYear: function() {
            return this.get('cc_year');
        },

        getNotes: function() {
            return this.get('notes');
        },

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_Teams = namespace.Model_Base.extend({

        // public
        id         : null,
        name       : null,
        league_type: null,
        league_id  : null,
        rank       : null,
        wins       : null,
        losses     : null,
        created_at : null,
        updated_at : null,

        // collection
        owner: null,

        // api
        url: Constants.API_URL + "/teams/{id}/",

        // maps
        model_map: {
            'owner': 'Model_Users'
        },


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getName: function() {
            return this.get('name');
        },

        getLeagueType: function() {
            return this.get('league_type');
        },

        getLeagueID: function() {
            return this.get('league_id');
        },

        getRank: function() {
            return this.get('rank');
        },

        getWins: function() {
            return this.get('wins');
        },

        getLosses: function() {
            return this.get('losses');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags,
        State     = namespace.State;

    namespace.Model_Threads = namespace.Model_Base.extend({

        // public
        id: null,
        created_at: null,
        updated_at: null,

        // model
        messages: null,
        participants: null,

        // api
        url: Constants.API_URL + "/messages/{id}/",

        // maps
        model_map: {
            'messages': 'Collection_Messages',
            'participants': 'Collection_Participants'
        },


        // Getters / Setters
        // ------------------------------------------------------------------

        getToUser: function() {
            var usr;

            this.participants.each(function(participant) {
                if (!State.user || participant.user.id != State.user.id) {
                    usr = participant.user;
                }
            });

            return usr;
        },

        /**
         * @todo, this needs to change. If we read someone elses conversations, it
         * won't be from us
         */
        getNotMe: function() {
            var usr;

            this.participants.each(function(participant) {
                if (!window['user'] || participant.user.id != user.id) {
                    usr = participant.user;
                }
            });

            return usr;
        },


        getLatestMessage: function() {
            return this.messages.last();
        },

        getURL: function() {
            return "/messages/" + this.id;
        },

        isRead: function() {
            var bool = false;

            this.participants.each(function(participant) {
                if (State.user && participant.user.id == State.user.id) {
                    if (participant.get("last_read").length > 1) {
                        // a higher number represents read
                        bool = moment(participant.get('last_read')).diff(this.get('updated_at'), 'minutes') >= 0;
                    }
                    // last read not set
                    else {
                        bool = false;
                    }
                }
            }, this);

            return bool;
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_TournamentsEntries = namespace.Model_Base.extend({

        // public
        id        : null,
        user_id   : null,
        price_paid: null,
        name      : null,
        rank      : null,
        status    : null,
        created_at: null,
        updated_at: null,

        // models
        user: null,

        // api
        url: Constants.API_URL + "/tournaments-entries/{id}/",

        // maps
        model_map: {
            'user': 'Model_Users'
        },


        // Getters
        // -------------------------------------------------------------

        getName: function() {
            return this.user ? this.user.getName() : this.get('name');
        },

        getRank: function() {
            return this.get('rank') || "Not set";
        },

        getThumbnailURL: function() {
            return this.user ? this.user.getThumbnailURL() : "/image/backgrounds/no-photos-user.jpg";
        },

        getURL: function() {
            return this.user ? this.user.getURL() : null;
        },

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_TournamentsPayments = namespace.Model_Base.extend({

        // public
        id           : null,
        tournament_id: null,
        name         : null,
        description  : null,
        price        : null,
        created_at   : null,
        updated_at   : null,

        // api
        url: Constants.API_URL + "/tournaments-payments/{id}/",


        // Getters
        // -------------------------------------------------------------

        getName: function() {
            return this.get('name');
        },

        getDescription: function() {
            return this.get('description');
        },

        getPrice: function() {
            return this.get('price');
        },

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags,
        State     = namespace.State;

    namespace.Model_Tournaments = namespace.Model_Base.extend({

        // public
        id              : null,
        name            : null,
        bracket_type    : null,
        accepts_payments: null,
        description     : null,
        max_players     : null,
        roster_count    : null,
        begins_at       : null,
        created_at      : null,
        updated_at      : null,

        // models
        brackets: null,
        roster  : null,
        payments: null,
        owner   : null,
        host    : null,
        venue   : null,

        // api
        url: Constants.API_URL + "/tournaments/{id}/",

        // maps
        model_map: {
            'owner'   : 'Model_Users',
            'host'    : 'Model_Users',
            'venue'   : 'Model_Venues',
            'payments': 'Collection_TournamentsPayments',
            'brackets': 'Collection_Brackets',
            'roster'  : 'Collection_TournamentsEntries',
        },


        // Helpers
        // -------------------------------------------------------------

        attend: function(attributes) {
            var self = this,
                entry;

            entry = new namespace.Model_TournamentsEntries({
                tournament_id: this.id
            });

            return entry.save().done(function() {
                // update cache key
                State.updateCacheKey();
            });
        },

        leave: function(attributes) {
            var self = this;

            for (var i in this.roster.models) {
                if (this.roster.models[i].user.id == user.id) {
                    return this.roster.models[i].destroy().done(function() {
                        // update cache key
                        State.updateCacheKey();
                    });
                }
            }

            return true;
        },


        // Getters
        // -------------------------------------------------------------

        acceptsPayments: function() {
            return this.get('accept_payments') == 1;
        },

        getBeginsAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('begins_at')).toDate() ).format(format = format || 'MMMM Do, YYYY h:mma')
                :  this.get('begins_at');
        },

        getBeginsAtFromNow: function() {
            return moment( moment.utc(this.get('begins_at')).toDate() ).fromNow();
        },

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getName: function() {
            return this.get('name');
        },

        getHost: function() {
            return this.host || this.owner;
        },

        /**
         * NOTE: This method performs a nl2br, which is uncommon
         */
        getDescription: function(br2nl) {
            var desc = (this.get('description') || "").toString();

            return br2nl ? desc : desc.replace(/\n/g, "<br>");
        },

        getEntryFee: function() {
            return this.get('entry_fee');
        },

        getMaxPlayers: function() {
            return parseFloat(this.get('max_players'));
        },

        getRowCount: function() {
            // 32 = 5, 16 = 4, 8 = 3, 4 = 2, 2 = 1
            return Math.floor(Math.log(this.getMaxPlayers()) / Math.log(2));
        },

        getBracketType: function() {
            return this.get('bracket_type');
        },

        getBracketTypeCaption: function() {
            switch (this.get('bracket_type')) {
                case 'single':
                    return 'Single Elimination';

                case 'double':
                    return 'Double Elimination';
            }
        },

        getURL: function() {
            return "/tournaments/" + this.id;
        },

        isAttending: function(user) {
            if (this.roster) {
                user = user || window['user'];

                for (var i in this.roster.models) {
                    if (this.roster.models[i].user && this.roster.models[i].user.id == user.id) {
                        return true;
                    }
                }
            }

            return false;
        },

        isSingleElimination: function() {
            return this.getBracketType() == 'single';
        },

        isDoubleElimination: function() {
            return this.getBracketType() == 'double';
        },


        // Template Helpers
        // ------------------------------------------------------------------

        getRowsPerRound: function(round) {
            return this.getMaxPlayers() / Math.pow(2, round);
        },

        findBracketEntry: function(round, order, side) {
            side || (side = 'a');

            side = side.toLowerCase();

            var item = this.brackets.findWhere({
                round: round,
                side : side,
                order: order
            });

            return item;
        },

        /**
         * @todo
         * Checks if entry from A exists over on B
         * It's a bit confusing right now, technical debt.
         */
        existsOnB: function(round, order) {
            if (this.findBracketEntry(round, order, "a")) {
                var entry = this.getEntryByBracketPosition(round, order, 'a');

                if (entry) {
                    return this.brackets.findWhere({
                        tournamententry_id: entry.id,
                        side: 'b',
                        round: round
                    });
                }
                else {
                    console.warn("Does not exist on B", round, order);
                }
            }

            return false;
        },

        getEntryByBracketPosition: function(round, order, side) {
            side || (side = 'a');

            var entry;

            side = side.toLowerCase();

            if (entry = this.findBracketEntry(round, order, side)) {
                return this.roster.findWhere({
                    id: entry.get('tournamententry_id')
                });
            }

            // error
            console.warn("Entry not found | round(" + round + ") order(" + order + ") side(" + side + ")");

            return null;
        },

        isEntryAWinner: function(round, order, side) {
            side || (side = 'a');

            var entry;

            side = side.toLowerCase();

            // check if bracket entry exists
            if (this.findBracketEntry(round, order, side)) {
                if (entry = this.getEntryByBracketPosition(round, order, side)) {
                    return this.brackets.isWinner(entry, round, side);
                }
            }

            return false;
        },

        isEntryALoser: function(round, order, side) {
            side || (side = 'a');

            var entry;

            side = side.toLowerCase();

            // evens go to odd, odd goes to even
            order += (order % 2 == 0) ? -1 : 1;

            // check if bracket entry exists
            if (this.findBracketEntry(round, order, side)) {
                if (entry = this.getEntryByBracketPosition(round, order, side)) {
                    return this.brackets.isWinner(entry, round, side);
                }
            }

            return false;
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags,
        State     = namespace.State;

    namespace.Model_Transactions = namespace.Model_Base.extend({

        // public
        id        : null,
        type      : null,
        type_id   : null,
        status    : null,
        amount    : null,
        currency  : null,
        user_id   : null,
        user_email: null,
        notes     : null,
        created_at: null,
        updated_at: null,

        // api
        url: Constants.API_URL + "/transactions/{id}",


        // Getters / Setters
        // ------------------------------------------------------------------

        getAmount: function() {
            return this.get('amount');
        },

        getAmountFormatted: function() {
            return "$" + this.getAmount() / 100;
        },

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getCreatedAtFromNow: function() {
            return moment( moment.utc(this.get('created_at')).toDate() ).fromNow();
        },

        getCurrency: function() {
            return this.get('currency');
        },

        getEmail: function() {
            return this.get('user_email');
        },

        getNotes: function() {
            return this.get('notes');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Events    = namespace.Events,
        Flags     = namespace.Flags,
        State     = namespace.State;

    namespace.Model_Users = namespace.Model_Base.extend({

        // public
        id        : null,
        name      : null,
        slug      : null,
        email     : null,
        phone     : null,
        lat       : null,
        lon       : null,
        status    : null,
        created_at: null,
        updated_at: null,

        ospn_user_id: null,
        ospn_push_token: null,

        // models
        accomplishments: null,
        checkins: null,
        games: null,
        media: null,
        meta: null,
        transactions: null,

        // api
        url: Constants.API_URL + "/users/{id}/",

        // maps
        model_map: {
            'accomplishments': 'Collection_Accomplishments',
            'checkins'       : 'Collection_Venues',
            'games'          : 'Collection_Meta',
            'media'          : 'Collection_Media',
            'meta'           : 'Collection_Meta'
        },


        initialize: function() {
            // super
            namespace.Model_Base.prototype.initialize.apply(this, arguments);

            // collections
            this.transactions = new namespace.Collection_Transactions({
                user_id: this.id
            });
        },


        // Actions
        // -------------------------------------------------------------

        login: function(attributes) {
            var self = this;

            return $.post(Constants.API_URL + "/auth/login/", {
                email: attributes.email,
                password: attributes.password
            }, function(response, status) {

                if (status == "success" && response.token) {

                    // set jwt token
                    State.set("token", response.token);

                    // user
                    State.set("user", response.user);

                    // set user data
                    self.set(response.user);

                    // check our push notification tokens
                    if (config.IS_APP) {
                        window.plugins.OneSignal.getIds(function(ids) {
                            self.set({
                                ospn_user_id   : ids.userId,
                                ospn_push_token: ids.pushToken
                            }).save();
                        });
                    }

                    // user cache
                    State.updateCacheKey();

                    // trigger
                    namespace.trigger(Events.LOGIN, response);
                }
            });
        },

        forgotPassword: function(attributes) {
            var self = this;

            return $.post(Constants.API_URL + "/auth/forgot-password/", {
                email: attributes.email
            }, function(response, status) {
                if (status == "success" && response.token) {
                    State.updateCacheKey();
                }
            });
        },

        resetPassword: function(attributes) {
            var self = this;

            return $.post(Constants.API_URL + "/auth/forgot-password/" + attributes.token, {
                password: attributes.password
            }, function(response, status) {
                if (status == "success" && response.token) {
                    State.updateCacheKey();
                }
            });
        },

        logout: function() {
            var self = this;

            return $.ajax({
                url    : Constants.API_URL + "/auth/logout/",
                cache  : false,
                headers: {
                    'Authorization-API': "Bearer " + State.get('token')
                },
                success: function(response, status) {
                    State.updateCacheKey();
                }
            });
        },

        me: function() {
            var self = this,
                token = State.get('token') || namespace.TOKEN;

            return $.ajax({
                url    : Constants.API_URL + "/me/",
                cache  : false,
                headers: {
                    'Authorization-API': "Bearer " + token
                },
                success: function(response, status) {
                    self.set(response);
                }
            });
        },

        fetchMessagesCount: function() {
            var self = this;

            return $.ajax({
                url    : Constants.API_URL + "/messages/count/",
                cache  : false,
                headers: {
                    'Authorization-API': "Bearer " + State.get('token')
                },
                success: function(response, status) {
                    if (status == "success") {
                        // set message count
                        State.set("messageCount", response);
                    }

                    // update
                    State.updateCacheKey();
                }
            });
        },


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at').date).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getBeaconsSent: function() {
            return this.getMetaValue("beacons_sent") || 0;
        },

        getBio: function() {
            return this.getMetaValue("brief_bio");
        },

        /**
         * @todo
         * Hook this up to actual API
         */
        getLastLocation: function() {
            return this.getMetaValue("last_location") || "";
        },

        getName: function() {
            return this.get('name');
        },

        getSlug: function() {
            return this.get('slug');
        },

        getEmail: function() {
            return this.get('email');
        },

        getPhone: function() {
            return this.get('phone');
        },

        getLatitude: function() {
            return this.get('lat');
        },

        getLongitude: function() {
            return this.get('lon');
        },

        getStatus: function() {
            return this.get('status');
        },

        getTalentLevel: function() {
            return this.getMetaValue("talent_level");
        },

        getTalentLevelWords: function(id) {
            var id = this.getMetaValue("talent_level");

            switch (id) {
                case '1': return "Inexperienced";
                case '2': return "Learning";
                case '3': return "Pretty Good";
                case '4': return "Solid";
                case '5': return "Well Rounded";
                case '6': return "Damn!";
                case '7': return "Intermediate";
                case '8': return "Advanced";
                case '9': return "Semi-Pro";
                case '10': return "Professional";
            }

            return "Not Set";
        },

        getThumbnailURL: function() {
            if (this.media && this.media.length) {
                return this.media.at(0).getURL();
            }

            return config.BASE_URL + "image/social/avatar.default.jpg";
        },

        getURL: function() {
            return "/users/" + this.id;
        },

        isMe: function() {
            return window.user && window.user.id == this.id;
        },

        isCheckedIn: function() {
            return false;
        },


        // Helpers
        // -----------------------------------------------------------------

        hasGameValue: function(field) {
            var field;

            if (!this.games) return false;

            if (field = this.games.findWhere({ key: field }) ) {
                return true;
            }

            return false;
        },

        getMetaValue: function(field) {
            var field;

            if (!this.meta) return false;

            if (field = this.meta.findWhere({ key: field }) ) {
                return field.get('value');
            }

            return "";
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_UsersPaymentAccount = namespace.Model_Base.extend({

        // public
        id                 : null,
        user_id            : null,
        first_name         : null,
        last_name          : null,
        account_holder_type: null,
        email              : null,
        country            : null,
        currency           : null,
        dob_month          : null,
        dob_day            : null,
        dob_year           : null,
        created_at         : null,
        updated_at         : null,

        // api
        url: Constants.API_URL + "/users/{user_id}/payment-account",


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getFirstName: function() {
            return this.get('first_name');
        },

        getLastName: function() {
            return this.get('last_name');
        },

        getAccountHolderType: function() {
            return this.get('account_holder_type');
        },

        getEmail: function() {
            return this.get('email');
        },

        getCountry: function() {
            return this.get('country');
        },

        getCurrency: function() {
            return this.get('currency');
        },

        getDOBMonth: function() {
            return this.get('dob_month');
        },

        getDOBDay: function() {
            return this.get('dob_day');
        },

        getDOBYear: function() {
            return this.get('dob_year');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags,
        State     = namespace.State;

    namespace.Model_Venues = namespace.Model_Base.extend({

        // public
        id         : null,
        name       : null,
        slug       : null,
        type       : null,
        address    : null,
        phone      : null,
        lat        : null,
        lon        : null,
        city       : null,
        state      : null,
        country    : null,
        zip        : null,
        description: null,
        notes      : null,
        created_at : null,
        updated_at : null,

        // models
        details: null,
        media: null,
        meta: null,

        // api
        url: Constants.API_URL + "/venues/{id}/",

        // maps
        model_map: {
            'checkins': 'Collection_VenuesCheckins',
            'details': 'Collection_Meta',
            'media': 'Collection_Media',
            'meta': 'Collection_Meta'
        },


        // Actions
        // -------------------------------------------------------------

        checkin: function(attributes) {
            var self = this;

            return $.ajax({
                url: Constants.API_URL + "/venues/" + this.id + "/checkin/",
                method: "POST",
                headers: {
                    'Authorization-API': "Bearer " + State.get('token')
                },
                success: function(response, status) {
                    // user cache
                    State.updateCacheKey();

                    router.reload();
                }
            });
        },


        // Getters
        // -------------------------------------------------------------

        getAddress: function(round) {
            return this.get('address');
        },

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        },

        getCheckinAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('checkin_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('checkin_at');
        },

        getCity: function() {
            return this.get('city');
        },

        getCreatedAtFromNow: function(formatted, format) {
            console.log( this.get('created_at') );
            return moment( moment.utc(this.get('created_at')).toDate() ).fromNow();
        },

        getCheckinAtFromNow: function() {
            return moment( moment.utc(this.get('checkin_at')).toDate() ).fromNow();
        },

        getCountry: function() {
            return this.get('country');
        },

        getDescription: function() {
            return this.get('description');
        },

        getDistance: function(round) {
            var distance = round ? parseFloat(this.get('distance')).toFixed(round) : this.get('distance');

            return isNaN(distance) ? "Unknown" : distance;
        },

        getDistanceFormatted: function(round) {
            var distance = round ? parseFloat(this.get('distance')).toFixed(round) : this.get('distance');

            return isNaN(distance) ? this.getCity() + ", " + this.getState() : distance + " mi";
        },

        getLatitude: function() {
            return this.get('lat');
        },

        getLongitude: function() {
            return this.get('lon');
        },

        getName: function() {
            return this.get('name');
        },

        getNotes: function() {
            return this.get('notes');
        },

        getPhone: function() {
            return this.get('phone');
        },

        getDisplayPhone: function() {
            return (this.getPhone() || '').toString().replace(/(\d{3})(\d{3})(\d{4})/, '($1) $2-$3');
        },

        getState: function() {
            return this.get('state');
        },

        getType: function() {
            return this.get('type');
        },

        getTitle: function() {
            return this.getName();
        },

        getThumbnailURL: function() {
            var url = '';

            if (this.media && this.media.length) {
                url = this.media.at(0).getURL();
                url = url.replace('-lg.jpg', '-thumb.jpg');
                url = url.replace('-lg.png', '-thumb.png');

                return url;
            }

            return config.BASE_URL + "image/backgrounds/no-photos-venue.jpg";
        },

        getWebsite: function() {
            return this.getMetaValue('website');
        },

        getURL: function() {
            return "/places/" + this.id;
        },

        getZip: function() {
            return this.get('zip');
        },

        isCheckedIn: function(user) {
            if (this.checkins) {
                user = user || window['user'];

                for (var i in this.checkins.models) {
                    if (this.checkins.models[i].user.id == user.id) {
                        return true;
                    }
                }
            }

            return false;
        },


        // Helpers
        // -----------------------------------------------------------------

        getMetaValue: function(field) {
            var field;

            if (!this.meta) return false;

            if (field = this.meta.findWhere({ key: field }) ) {
                return field.get('value');
            }

            return "";
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        Flags     = namespace.Flags;

    namespace.Model_VenuesCheckins = namespace.Model_Base.extend({

        // public
        id        : null,
        venue_id  : null,
        user_id   : null,
        created_at: null,
        updated_at: null,

        // models
        user: null,

        // api
        url: Constants.API_URL + "/venues/{id}/checkin",

        // maps
        model_map: {
            'user': 'Model_Users'
        },


        // Getters
        // -------------------------------------------------------------

        getCreatedAt: function(formatted, format) {
            return formatted
                ? moment( moment.utc(this.get('created_at')).toDate() ).format(format = format || 'MMMM Do, YYYY')
                :  this.get('created_at');
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Accomplishments = namespace.Collection_Base.extend({

        model: namespace.Model_Accomplishments,
        url  : Constants.API_URL + "/accomplishments/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Beacons = namespace.Collection_Base.extend({

        model: namespace.Model_Beacons,
        url  : Constants.API_URL + "/beacons/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants,
        State = namespace.State;

    namespace.Collection_Brackets = namespace.Collection_Base.extend({

        model   : namespace.Model_Brackets,
        url     : Constants.API_URL + "/brackets/",

        // <String> Order brackets in the proper way
        sort_key: 'id',


        // Getters
        // -------------------------------------------------------------------

        clear: function(attributes) {
            var self = this,
                models = [];

            for (var i in this.models) {
                models.push(this.models[i]);
            }

            for (i in models) {
                console.log( "Removing " + models[i].getTournamentEntryID() );

                models[i].destroy();
            }
        },

        getByRound: function(round) {
            return this.filter(function(model) {
                return model.getRound() == round;
            });
        },

        getMaxRounds: function() {
            var max = 0;

            this.each(function(model) {
                max = Math.max(max, model.getRound());
            }, this);

            return max;
        },

        hasEntry: function(entry) {
            return this.find(function(m) {
                return m.get('tournamententry_id') == entry.id
            });
        },

        isWinner: function(entry, round, side) {
            side || (side = 'a');

            return this.find(function(m) {
                return parseFloat(m.get('tournamententry_id')) == entry.id
                 && parseFloat(m.get('round')) == round + 1
                 && m.get('side') == side
            });
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Content = namespace.Collection_Base.extend({

        model: namespace.Model_Content,
        url  : Constants.API_URL + '/content/',

        // <String> Key to sort by
        sort_key: 'created_at',

        comparator: function(item) {
            return - item.get(this.sort_key);
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Feed = namespace.Collection_Base.extend({

        model   : namespace.Model_Feed,
        url     : Constants.API_URL + '/feed/'

        // <String> Key to sort by
        // sort_key: 'created_at'

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Games = namespace.Collection_Base.extend({

        model: namespace.Model_Games,
        url  : Constants.API_URL + "/games/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Matches = namespace.Collection_Base.extend({

        model: namespace.Model_Matches,
        url  : Constants.API_URL + "/matches/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Media = namespace.Collection_Base.extend({

        model: namespace.Model_Media,
        url  : Constants.API_URL + "/#/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Messages = namespace.Collection_Base.extend({

        model: namespace.Model_Messages,
        url  : Constants.API_URL + '/#/',

        // <String> Key to sort by
        sort_key: 'updated_at'

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Meta = namespace.Collection_Base.extend({

        model: namespace.Model_Meta,
        url  : Constants.API_URL + "/#/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Nights = namespace.Collection_Base.extend({

        model: namespace.Model_Nights,
        url  : Constants.API_URL + "/nights/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Participants = namespace.Collection_Base.extend({

        model: namespace.Model_Participants,
        url  : Constants.API_URL + "/#/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Teams = namespace.Collection_Base.extend({

        model: namespace.Model_Teams,
        url  : Constants.API_URL + "/teams/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Threads = namespace.Collection_Base.extend({

        model: namespace.Model_Threads,
        url  : Constants.API_URL + "/messages/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_TournamentsEntries = namespace.Collection_Base.extend({

        model: namespace.Model_TournamentsEntries,
        url  : Constants.API_URL + "/tournaments-entries/",


        // Getters
        // ----------------------------------------------------------------

        findByBracket: function(bracket) {
            return this.findWhere({
                id: bracket.getTournamentEntryID()
            });
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_TournamentsPayments = namespace.Collection_Base.extend({

        model: namespace.Model_TournamentsPayments,
        url  : Constants.API_URL + "/tournaments-payments/"

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Tournaments = namespace.Collection_Base.extend({

        model: namespace.Model_Tournaments,
        url  : Constants.API_URL + "/tournaments/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Transactions = namespace.Collection_Base.extend({

        model: namespace.Model_Transactions,
        url  : Constants.API_URL + "/users/{user_id}/transactions",

        // for whom
        user_id: null,


        initialize: function(options) {
            options || (options = {});

            // super
            namespace.Collection_Base.prototype.initialize.call(this, options);

            // set
            this.user_id = options.user_id;
        }

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Users = namespace.Collection_Base.extend({

        model: namespace.Model_Users,
        url  : Constants.API_URL + "/users/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_Venues = namespace.Collection_Base.extend({

        model: namespace.Model_Venues,
        url  : Constants.API_URL + "/venues/",

    });

})(window.pm || (window.pm = {}));


;(function(namespace) {
    'use strict';

    var Constants = namespace.Constants;

    namespace.Collection_VenuesCheckins = namespace.Collection_Base.extend({

        model: namespace.Model_VenuesCheckins,
        url  : Constants.API_URL + "/venues/",

    });

})(window.pm || (window.pm = {}));
